<?php
  $success = false;
  if (isset($_POST['save'])) {
    if (preg_match('/[a-z][a-z]/i', @$_POST['default-language'])) {
      i18n_set_property(I18N_PROP_DEFAULT_LANGUAGE, $_POST['default-language']);
      $msg = i18n_r('i18n_base/SAVE_SUCCESS');
      $success = true;
    } else {
      $msg = i18n_r('i18n_base/SAVE_FAILURE');
    }
  }
  $deflang = return_i18n_default_language();
  $pages = array();
  $languages = array();
	$dir_handle = @opendir(GSDATAPAGESPATH) or die("Unable to open pages directory");
  $files_to_ignore = '/^('.i18n_get_property(I18N_PROP_URLS_TO_IGNORE, '').')\.xml$/';
	while ($filename = readdir($dir_handle)) {
    if (strrpos($filename,'.xml') === strlen($filename)-4 && !is_dir(GSDATAPAGESPATH . $filename) && !preg_match($files_to_ignore, $filename)) {
			$data = getXML(GSDATAPAGESPATH . $filename);
      if (strpos($filename,'_') !== false) {
        $pos = strpos($data->url,'_');
        $url = substr($data->url,0,$pos);
        $lang = substr($data->url,$pos+1);
        if (!in_array($lang,$languages)) $languages[] = $lang;
        if (!isset($pages[$url])) {
          $pages[$url] = array('url' => $url, 'variants' => array(), 'exists' => false, 'title' => '', 'menuOrder' => 99, 'parent' => null);
        }
        $pages[$url]['variants'][$lang] = array();
        $pages[$url]['variants'][$lang]['url'] = (string) $data->url;
        $pages[$url]['variants'][$lang]['parent'] = (string) $data->parent;
        $pages[$url]['variants'][$lang]['title'] = (string) $data->title;
        $pages[$url]['variants'][$lang]['date'] = $data->pubDate;
      } else {
        $url = '' . $data->url;
        if (!isset($pages[$url])) {
          $pages[$url] = array('url' => $url, 'variants' => array());
        }
        $pages[$url]['exists'] = true;
        $pages[$url]['parent'] = (string) $data->parent;
			  $pages[$url]['title'] = (string) $data->title;
        $pages[$url]['metak'] = (string) $data->meta;
        $pages[$url]['metad'] = (string) $data->metad;
			  $pages[$url]['menuStatus'] = (string) $data->menuStatus;
			  $pages[$url]['menuOrder'] = (int) $data->menuOrder;
        $pages[$url]['private'] = (string) $data->private;
        $pages[$url]['date'] = $data->pubDate;
      }
      $parent = (string) $data->parent;
      if ($parent && !isset($pages[$parent])) {
        $pages[$parent] = array('url' => $parent, 'variants' => array(), 'exists' => false, 'title' => '', 'menuOrder' => 99, 'parent' => null);
      }
    }
	}
  sort($languages);
  // sort pages
  $view = @$_REQUEST['view'];
  if (!$view) {
    $view = i18n_get_property(I18N_PROP_PAGES_VIEW, 'hierarchical');
  } else if ($view != i18n_get_property(I18N_PROP_PAGES_VIEW, null)) {
    i18n_set_property(I18N_PROP_PAGES_VIEW, $view);
  }
  if (count($pages) > 0) foreach ($pages as &$page) {
    if ($view == 'hierarchical') {
      $level = -1;
      $sort = '';
      for ($p = $page; $p; $p = $p['parent'] ? $pages[$p['parent']] : null) {
        $sort = sprintf('%03d',$p['menuOrder']).$p['title'].' '.$sort;
        $level++;
      }
      $page['level'] = $level;
      $page['sort'] = $sort;
    } else {
      $page['sort'] = $page['title'];
    }
  }
  $isHierarchical = $view == 'hierarchical';
  $pages = subval_sort($pages,'sort');
  $counter = count($pages);
  // display overview
  $link = "load.php?id=i18n_base";
?>
			<h3 class="floated" style="float:left"><?php echo i18n_r('PAGE_MANAGEMENT'); ?></h3>
			<div class="edit-nav" >
        <p>
          <?php echo i18n_r('TOGGLE_STATUS'); ?> &nbsp;<input type="checkbox" id="show-characters" value="" />
          &nbsp;&nbsp;
          <?php echo i18n_r('i18n_base/FILTER'); ?>: <input type="text" id="filter" value="" class="text" style="width:80px"/>
          <a href="<?php echo $link; ?>&view=hierarchical" <?php echo $view=='hierarchical' ? 'class="current"' : ''; ?> ><? echo i18n_r('i18n_base/VIEW_HIERARCHICAL'); ?></a>
          <a href="<?php echo $link; ?>&view=title" <?php echo $view=='title' ? 'class="current"' : ''; ?> ><? echo i18n_r('i18n_base/VIEW_TITLE'); ?></a>
        </p>
        <div class="clear" ></div>
      </div>
      <p><?php echo i18n_r('i18n_base/NEW_LANGUAGE_DESCR'); ?></p>
      <form action="<?php echo $link; ?>" method="post" style="margin-bottom:10px">
        <span><?php i18n('i18n_base/DEFAULT_LANGUAGE_DESCR'); ?></span> 
        <input type="text" name="default-language" value="<?php echo $deflang; ?>" maxlength="2" style="width:2em;"/> &nbsp; 
        <input type="submit" name="save" value="<?php i18n('i18n_base/SAVE_DEFAULT_LANGUAGE'); ?>"/> 
      </form>
			<table id="editpages" class="edittable highlight">
        <?php if (count($languages) > 0) { ?>
        <thead>
          <tr><th colspan="3" style='font-weight:800'><?php echo $deflang; ?></th><?php foreach ($languages as $lang) echo "<th colspan='3' style='font-weight:800'>$lang</th>"; ?></tr>
        </thead>
        <?php } ?>
        <tbody>
        <?php
          foreach ($pages as &$page) {
        ?>
          <tr id="tr-<?php echo $page['url']; ?>">
        <?php
            if ($page['exists']) {
              if ($page['title'] == '') $page['title'] = '[No Title] &nbsp;&raquo;&nbsp; <em>'. $page['url'] .'</em>'; 
              $status = '';
	            if ($page['url'] == 'index' ) $status .= ' <sup>['.i18n_r('HOMEPAGE_SUBTITLE').']</sup>'; 
	            if ($page['menuStatus'] != '' ) $status .= ' <sup>['.i18n_r('MENUITEM_SUBTITLE').']</sup>';
	            if ($page['private'] != '' ) $status .= ' <sup>['.i18n_r('PRIVATE_SUBTITLE').']</sup>'; 
        ?>
            <td <?php echo $isHierarchical ? 'style="padding-left:'.(4+20*$page['level']).'px"' : ''; ?> >
              <input type="hidden" name="title" value="<?php echo cl($page['title']); ?>"/>
              <a title="<?php echo i18n_r('EDITPAGE_TITLE').': '.cl($page['title']).' - '.shtDate($page['date']); ?>" href="edit.php?id=<?php echo $page['url']; ?>"><?php echo cl($page['title']); ?></a>
              <span class="showstatus toggle"><?php echo $status; ?></span>
            </td>
	          <td class="secondarylink">
	            <a title="<?php echo i18n_r('VIEWPAGE_TITLE').': '. cl($page['title']); ?>" target="_blank" href="<? echo find_url($page['url'],$page['parent']); ?>">#</a>
	          </td>
	          <td class="delete" >
              <a class="i18n-delconfirm" href="deletefile.php?id=<?php echo $page['url']; ?>&nonce=<?php echo get_nonce("delete", "deletefile.php"); ?>" title="<?php echo i18n_r('DELETEPAGE_TITLE').': '.cl($page['title']); ?>">X</a>
            </td>
        <?php
            } else {
        ?>
            <td></td>
            <td></td>
            <td class="secondarylink">            
              <a href="edit.php?newid=<?php echo $page['url']; ?>" title="<?php echo i18n_r('CREATE_NEW_PAGE').': '.$page['url']; ?>">+</a>
            </td>
        <?php
            }
            foreach ($languages as $lang) {
              $params = 'newid='.$page['url'].'_'.$lang;
              $title = i18n_r('CREATE_NEW_PAGE').': ';
              if ($page['exists']) {
                $params .= '&title='.urlencode($page['title'].' ('.$lang.')').
                           '&metak='.urlencode($page['metak']).
                           '&metad='.urlencode($page['metad']);
                $title .= cl($page['title']).' ('.$lang.')';
              } else {
                $title .= $page['url'].'_'.$lang;
              }
              if (isset($page['variants'][$lang])) {
                $variant =& $page['variants'][$lang];
                if ($variant['title'] == '') $variant['title'] = '[No Title] &nbsp;&raquo;&nbsp; <em>'. $variant['url'] .'</em>'; 
        ?> 
            <td>
              <input type="hidden" name="title" value="<?php echo cl($variant['title']); ?>"/>
              <a title="<?php echo i18n_r('EDITPAGE_TITLE').': '.cl($variant['title']).' - '.shtDate($variant['date']); ?>" href="edit.php?id=<?php echo $variant['url']; ?>"><?php echo cl($variant['title']); ?></a>
            </td>
	          <td class="secondarylink">
	            <a title="<?php echo i18n_r('VIEWPAGE_TITLE').': '.cl($variant['title']); ?>" target="_blank" href="<? echo find_url($page['url'],$page['parent']).'?lang='.$lang; ?>">#</a>
	          </td>
	          <td class="delete" >
              <a class="i18n-delconfirm" href="deletefile.php?id=<?php echo $variant['url']; ?>&nonce=<?php echo get_nonce("delete", "deletefile.php"); ?>" title="<?php echo i18n_r('DELETEPAGE_TITLE').': '.cl($variant['title']); ?>">X</a>
              <a href="edit.php?<?php echo $params; ?>" title="<?php echo $title; ?>" style="display:none">+</a>
            </td>
        <?php
              } else {
        ?>
            <td></td>
            <td></td>
            <td class="secondarylink">            
              <a href="edit.php?<?php echo $params; ?>" title="<?php echo $title; ?>">+</a>
            </td>
        <?php
              }
            }
        ?>
           </tr>
        <?php
          }
        ?>
        </tbody>
			</table>
			<div id="page_counter" class="qc_pager"></div> 	
			<p><em><b><span id="pg_counter"><?php echo $counter; ?></span></b> <?php echo i18n_r('TOTAL_PAGES'); ?></em></p>
      <script type="text/javascript">
        function filterPages() {
          var s = $('#filter').val().toLowerCase();
//alert(s);
          if (s == '') {
//alert('all visible');
            $('#editpages tbody tr').css('display', 'table-row');
          } else {
            $('#editpages tbody tr').each(function(i,tr) {
              var found = false;
              $(tr).find('input[name=title]').each(function(k,input) {
//alert($(input).val());
                if ($(input).val().toLowerCase().indexOf(s) >= 0) found = true;
              });
              $(tr).css('display', found ? 'table-row' : 'none');
            });
          }
        }
        $(function() {
          $('#filter').keyup(filterPages);
	        $(".i18n-delconfirm").live("click", function(e) {
		        var message = $(this).attr("title");
		        var dlink = $(this).attr("href");
	          var answer = confirm(message);
            if (answer){
	            $.ajax({
                 type: "GET",
                 url: dlink,
                 success: function(response) {
                    if ($(e.target).closest('tr').find('a').length > 4) {
                      var $td=$(e.target).closest('td');
                      $(e.target).remove();
                      $td.prev().prev().empty();
                      $td.prev().empty();
                      $td.removeClass('delete').addClass('secondarylink');
                      $td.find('a').attr('style',null);
                    } else {
                      $(e.target).closest('tr').remove();
                      $("#page_counter").html("");
                      if($("#pg_counter").length) {
                    	  counter=$("#pg_counter").html();
                        $("#pg_counter").html(counter-1);
                      }
                      $('table.paginate tr').quickpaginate( { perpage: 15, showcounter: true, pager : $("#page_counter") } );
                    }                  
                    //added by dniesel
                    if($(response).find('div.error').html()) {
                      $('div.bodycontent').before('<div class="error">'+ $(response).find('div.error').html() + '</div>'); 
                    }
                    if($(response).find('div.updated').html()) {
                      $('div.bodycontent').before('<div class="updated">'+ $(response).find('div.updated').html() + '</div>'); 
                    }
                 }
              });
            }
            return false;	            
	        });
          filterPages();
          $('#filter').focus();
<?php if (isset($msg)) { ?>
          $('div.bodycontent').before('<div class="<?php echo $success ? 'updated' : 'error'; ?>" style="display:block;">'+<?php echo json_encode($msg); ?>+'</div>');
<?php } ?>
        });
      </script>

