<?php
  function i18n_navigation_structure_load(&$pages, &$languages) {
    $pages = array();
    $languages = array();
    $is_i18n = function_exists('return_i18n_default_language');
	  $dir_handle = @opendir(GSDATAPAGESPATH) or die("Unable to open pages directory");
    $files_to_ignore = function_exists('i18n_get_property') ? '/^('.i18n_get_property(I18N_PROP_URLS_TO_IGNORE, '').')\.xml$/' : '/^$/';
	  while ($filename = readdir($dir_handle)) {
      if (strrpos($filename,'.xml') === strlen($filename)-4 && !is_dir(GSDATAPAGESPATH . $filename) && !preg_match($files_to_ignore, $filename)) {
			  $data = getXML(GSDATAPAGESPATH . $filename);
        $url = (string) $data->url;
        if ($is_i18n && strpos($url,'_') !== false) {
          $lang = substr($url, strpos($url,'_')+1);
          $url = substr($url, 0, strpos($url,'_'));
          if (!in_array($lang, $languages)) $languages[] = $lang;
          if (!isset($pages[$url])) {
            $pages[$url] = array('url' => $url, 'variants' => array(), 'exists' => false, 'title' => '', 'menuOrder' => 99, 'parent' => null);
          }
          $pages[$url]['variants'][$lang] = array('url' => $url.'_'.$lang);
          $pages[$url]['variants'][$lang]['language'] = $lang;
          $pages[$url]['variants'][$lang]['title'] = (string) $data->title;
          $pages[$url]['variants'][$lang]['menu'] = (string) $data->menu;
          $pages[$url]['variants'][$lang]['accesskey'] = (string) $data->accesskey;
          $pages[$url]['variants'][$lang]['taborder'] = (int) $data->taborder;
        } else {
          if (!isset($pages[$url])) {
            $pages[$url] = array('url' => $url, 'variants' => array());
          }
          $pages[$url]['exists'] = true;
          $pages[$url]['parent'] = (string) $data->parent;
			    $pages[$url]['title'] = (string) $data->title;
          $pages[$url]['menu'] = (string) $data->menu;
			    $pages[$url]['menuStatus'] = (string) $data->menuStatus;
			    $pages[$url]['menuOrder'] = (int) $data->menuOrder;
          $pages[$url]['date'] = $data->pubDate;
          $pages[$url]['accesskey'] = (string) $data->accesskey;
          $pages[$url]['taborder'] = (int) $data->taborder;
        }
      }
	  }
    closedir($dir_handle);
    sort($languages);
  }

  function i18n_navigation_structure_save(&$pages) {
    $stack = array();
    for ($i=0; !isset($msg) && isset($_POST['page_'.$i.'_url']); $i++) {
      $url = $_POST['page_'.$i.'_url'];
      if (isset($pages[$url])) {
        $level = (int) $_POST['page_'.$i.'_level'];
        if ($level > count($stack)) $level = count($stack);
        $parent = $level <= 0 ? '' : $stack[$level-1];
        $menuOrder = count($stack) <= $level ? 0 : $pages[$stack[$level]]['menuOrder'] + 1;
        $menu = htmlentities($_POST['page_'.$i.'_menu'], ENT_QUOTES, 'UTF-8');
        if ($menu == $pages[$url]['title']) $menu = '';
        if ($parent != $pages[$url]['parent'] || $menuOrder != $pages[$url]['menuOrder'] || $menu != $pages[$url]['menu']) {
          // update pages array
          $pages[$url]['parent'] = $parent;
          $pages[$url]['menuOrder'] = $menuOrder;
          $pages[$url]['menu'] = $menu;
          // backup page file
          if (!copy(GSDATAPAGESPATH . $url . '.xml', GSBACKUPSPATH . 'i18n_navigation/' . $url . '.xml')) return false;
          // update page file
    			$data = getXML(GSDATAPAGESPATH . $url . '.xml');
	        $xml = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><item></item>');
	        $xml->addChild('pubDate', (string) $data->pubDate);
          foreach ($data->children() as $child) {
            $name = $child->getName();
            if ($name != 'parent' && $name != 'menuOrder' && $name != 'menu' && $name != 'pubDate') {
              $xml->addChild($name)->addCData((string) $child);
            }
          }
	        $xml->addChild('parent')->addCData((string) $parent);
	        $xml->addChild('menuOrder')->addCData((string) $menuOrder);
	        $xml->addChild('menu')->addCData((string) $menu);
       		XMLsave($xml, GSDATAPAGESPATH . $url . '.xml');
        }
        // variants
        if (count($pages[$url]['variants']) > 0) foreach ($pages[$url]['variants'] as $lang => &$variant) {
          if (isset($_POST['page_'.$i.'_menu'.$lang])) {
            $menu = htmlentities($_POST['page_'.$i.'_menu'.$lang], ENT_QUOTES, 'UTF-8');
            if ($menu == $variant['title']) $menu = '';
            if ($menu != $variant['menu']) {
              $variant['menu'] = $menu;
              // backup variant file
              if (!copy(GSDATAPAGESPATH . $variant['url'] . '.xml', GSBACKUPSPATH . 'i18n_navigation/' . $variant['url'] . '.xml')) return false;
              // update variant file
        			$data = getXML(GSDATAPAGESPATH . $variant['url'] . '.xml');
              $xml = @new SimpleXMLExtended('<?xml version="1.0" encoding="UTF-8"?><item></item>');
              $xml->addChild('pubDate', (string) $data->pubDate);
              foreach ($data->children() as $child) {
                $name = $child->getName();
                if ($name != 'menu' && $name != 'menuStatus' && $name != 'pubDate') {
                  $xml->addChild($name)->addCData((string) $child);
                }
              }
              $xml->addChild('menu')->addCData((string) $menu);
              $xml->addChild('menuStatus')->addCData('Y');
           		XMLsave($xml, GSDATAPAGESPATH . $variant['url'] . '.xml');
            }
          }
        }
        while (count($stack) > $level) array_pop($stack);
        array_push($stack, $url);
      }
    }
    return true;
  }

  function i18n_navigation_structure_undo() {
    $dir = GSBACKUPSPATH . 'i18n_navigation/';
	  $dir_handle = @opendir($dir);
    if (!$dir_handle) return false;
    while ($filename = readdir($dir_handle)) {
      if (!is_dir($dir . $filename)) {
        if (!copy($dir . $filename, GSDATAPAGESPATH . $filename)) {
          closedir($dir_handle);
          return false;
        }
      }
    }
    closedir($dir_handle);
    return true;
  }

  global $SITEURL, $LANG;
  $def_language = function_exists('return_i18n_default_language') ? return_i18n_default_language() : $LANG;
  if (!isset($_POST['save']) && isset($_GET['undo'])) {
    if (i18n_navigation_structure_undo()) {
      $msg = i18n_r('i18n_navigation/UNDO_SUCCESS');
      $success = true;
    } else {
      $msg = i18n_r('i18n_navigation/UNDO_FAILURE');
    }
  }
  i18n_navigation_structure_load($pages, $languages);
  if (isset($_POST['save'])) {
    $dir = GSBACKUPSPATH . 'i18n_navigation/';
    // create directory if necessary
    if (!file_exists($dir)) {
      @mkdir(substr($dir,0,strlen($dir)-1), 0777);
      $fp = @fopen($dir . '.htaccess', 'w');
      if ($fp) {
        fputs($fp, 'Deny from all');
        fclose($fp);
      }
    }
    // delete old backup files
	  $dir_handle = @opendir($dir);
    if ($dir_handle) {
      while ($filename = readdir($dir_handle)) {
        if (!is_dir($dir . $filename)) unlink($dir . $filename);
      }
      closedir($dir_handle);
    }
    // save
    if (i18n_navigation_structure_save($pages)) {
      $msg = i18n_r('i18n_navigation/SAVE_SUCCESS').' <a href="load.php?id=i18n_navigation&undo">' . i18n_r('UNDO') . '</a>';
      $success = true;
      i18n_clear_cache();
    } else {
      $msg = i18n_r('i18n_navigation/SAVE_FAILURE');
      if (!i18n_navigation_structure_undo()) i18n_clear_cache();
      i18n_navigation_structure_load($pages, $languages);
    }
  }
  // sort pages
  if (count($pages) > 0) foreach ($pages as &$page) {
    if ($page['parent'] && !isset($pages[$page['parent']])) $page['parent'] = null;
    $level = -1;
    $sort = '';
    for ($p = $page; $p && $level<20; $p = $p['parent'] ? $pages[$p['parent']] : null) {
      $sort = sprintf('%03d',$p['menuOrder']).$p['title'].' '.$sort;
      $level++;
    }
    $page['level'] = $level;
    $page['sort'] = $sort;
  }
  $pages = subval_sort($pages,'sort');
  $i = 0;
?>
		<h3 class="floated" style="float:left"><?php echo i18n_r('i18n_navigation/NAVIGATION'); ?></h3>
    <p class="clear"><?php i18n('i18n_navigation/NAVIGATION_DESCR'); ?></p>
<?php if (count($languages) > 0) { ?>
    <p>
      <?php i18n('i18n_navigation/LANGUAGE_DESCR'); ?>
      <select name="navlang" class="text" id="navlang">
        <?php echo '<option value="" selected="selected">'.$def_language.'</option>'; ?>
        <?php foreach ($languages as $language) echo '<option>'.$language.'</option>'; ?>
      </select>.
    </p>
<?php } ?>
    <form method="post" id="navigationForm" action="load.php?id=i18n_navigation">
			<table id="editnav" class="edittable highlight">
        <tbody>
        <?php
          foreach ($pages as &$page) {
            if ($page['exists']) {
              $isMenu = @$page['menuStatus'] == 'Y';
              $menu = $isMenu && @$page['menu'] ? $page['menu'] : $page['title'];
              $notitle = '[No Title] &nbsp;&raquo;&nbsp; <em>'. $page['url'] .'</em>'; 
        ?>
          <tr id="tr-<?php echo $page['url']; ?>">
            <td style="<?php echo 'padding-left:'.(4+20*$page['level']).'px;' . ($page['menuStatus'] != 'Y' ? 'color:gray;' : ''); ?>" title="<?php echo $isMenu ? cl($page['title']) : ''; ?>">
              <input type="hidden" name="page_<?php echo $i; ?>_menuStatus" value="<?php echo $page['menuStatus']; ?>"/>
              <input type="hidden" name="page_<?php echo $i; ?>_url" value="<?php echo $page['url']; ?>"/>
              <input type="hidden" name="page_<?php echo $i; ?>_level" value="<?php echo 0+$page['level']; ?>"/>
              <span class="modifyable menu" style="color:inherit;font-size:inherit;line-height:inherit;"><?php echo stripslashes(htmlspecialchars_decode($isMenu ? $menu : $page['title'],ENT_QUOTES)); ?></span>
              <sup style="display:none;"><?php echo $def_language; ?></sup>
              <input class="modifyable menu text" style="display:none;width:20em;" name="page_<?php echo $i; ?>_menu" value="<?php echo stripslashes($isMenu ? $menu : $page['title']); ?>"/>
<?php if (count($page['variants']) > 0) foreach ($page['variants'] as $lang => $variant) { ?>
              <span class="modifyable menu<?php echo $lang; ?>" style="display:none;color:inherit;font-size:inherit;line-height:inherit;"><?php echo stripslashes(htmlspecialchars_decode($variant['menu'] ? $variant['menu'] : $variant['title'],ENT_QUOTES)); ?></span>
              <input class="modifyable menu<?php echo $lang; ?> text" style="display:none;width:20em;" name="page_<?php echo $i; ?>_menu<?php echo $lang; ?>" value="<?php echo stripslashes($variant['menu'] ? $variant['menu'] : $variant['title']); ?>"/>
<?php } ?>
            </td>
            <td class="secondarylink"><a href="#" class="moveLeft" title="<?php i18n('i18n_navigation/OUTDENT'); ?>">&lt;</a></td>
            <td class="secondarylink"><a href="#" class="moveRight" title="<?php i18n('i18n_navigation/INDENT'); ?>">&gt;</a></td>
	          <td class="secondarylink">
	            <a title="<?php echo i18n_r('VIEWPAGE_TITLE').': '. cl($page['title']); ?>" target="_blank" href="<? echo find_url($page['url'],$page['parent']); ?>">#</a>
	          </td>
           </tr>
        <?php
              $i++;
            }
          }
        ?>
        </tbody>
			</table>
      <input type="submit" name="save" value="<?php i18n('i18n_navigation/SAVE_NAVIGATION'); ?>" class="submit"/>
    </form>
    <script type="text/javascript" src="<?php echo $SITEURL; ?>/plugins/i18n_navigation/js/jquery-ui.sort.min.js"></script>
    <script type="text/javascript">
      var lang = '';
      function getLevel($tr) {
        var level = parseInt($tr.find('[name$=level]').val());
        return level;
      }
      function setLevel($tr, level) {
        $tr.find('[name$=level]').val(level);
        $tr.find('td:first').css('padding-left', (4+20*level)+'px');
      }
      function moveLeft(e) {
        var $tr = $(e.target).closest('tr');
        var level = getLevel($tr);
        var nextlevel = getLevel($tr.next());
        if (level > 0 && nextlevel <= level) setLevel($tr, level-1); 
        e.preventDefault();
      }
      function moveRight(e) {
        var $tr = $(e.target).closest('tr'); 
        var level = getLevel($tr);
        var prevlevel = getLevel($tr.prev());
        if (prevlevel >= level) setLevel($tr, level+1);
        e.preventDefault();
      }
      function drop(e,ui) {
        var $tr = $(ui.item).closest('tr'); 
        var level = getLevel($tr);
        var prevlevel = getLevel($tr.prev());
        var nextlevel = getLevel($tr.next());
        if (prevlevel == null) {
          setLevel($tr, 0);
        } else if (prevlevel+1 < level) {
          setLevel($tr, prevlevel+1);
        } else if (nextlevel && level < nextlevel-1) {
          setLevel($tr, nextlevel-1);
        }
        renumberRows();
      }
      function renumberRows() {
        var oldlevel = -1;
        $('#editnav tbody tr').each(function(i,tr) {
          $tr = $(tr);
          $tr.find('input, select, textarea').each(function(k,elem) {
            var name = $(elem).attr('name').replace(/_\d+_/, '_'+(i)+'_');
            $(elem).attr('name', name);
          });
          var level = getLevel($tr);
          if (level > oldlevel+1) setLevel($tr, oldlevel+1); else setLevel($tr, level);
          oldlevel = level;
        });
      }
      function startEdit(e) {
        $('#editnav tbody input.menu'+lang+':visible').each(function(i,input) {
          $(input).css('display','none');
          if (input.value == '') input.value = $(input).closest('td').attr('title');
          $(input).closest('td').find('span.menu'+lang).html($(input).val()).css('display','inline');
        });
        if ($(e.target).closest('td').find('input[name$=menuStatus]').val() != 'Y') return;
        if (!$(e.target).closest('span').hasClass('menu'+lang)) return;
        $(e.target).closest('span').css('display','none');
        $(e.target).closest('td').find('input.menu'+lang).css('display','inline').focus();
      }
      function finishEdit(e) {
        $(e.target).css('display','none');
        if (e.target.value == '') e.target.value = $(e.target).closest('td').attr('title');
        $(e.target).closest('td').find('span.menu'+lang).html($(e.target).val()).css('display','inline');
      }
      function changeLanguage(e) {
        if (lang != '') {
          $('#editnav .menu'+lang).css('display','none');
          $('#editnav sup').css('display','none');
        }
        $('#editnav span.menu').css('display','inline');
        lang = $('#navlang').val();
        if (lang != '') {
          $('#editnav sup').css('display','inline');
          $('#editnav span.menu'+lang).each(function(i,span) {
            $(span).closest('td').find('span.menu, sup').css('display','none');
            $(span).css('display','inline');
          });
        }
      }
      $(function() {
        $('#navlang').val('');
        $('#navigationForm').get(0).reset();
        $('#editnav .moveLeft').click(moveLeft);
        $('#editnav .moveRight').click(moveRight);
        $('#editnav tbody').sortable({
          items:"tr", handle:'td',
          update:drop
        });
        renumberRows();
        $('#editnav span.modifyable').click(startEdit);
        $('#editnav input.modifyable').blur(finishEdit);
        $('#navlang').change(changeLanguage);
<?php if (isset($msg)) { ?>
        $('div.bodycontent').before('<div class="<?php echo $success ? 'updated' : 'error'; ?>" style="display:block;">'+<?php echo json_encode($msg); ?>+'</div>');
	      $(".updated, .error").fadeOut(500).fadeIn(500);
<?php } ?>
      });
    </script>

